Index: wp-content/themes/classic/rtl.css
===================================================================
--- wp-content/themes/classic/rtl.css	(revision 0)
+++ wp-content/themes/classic/rtl.css	(revision 0)
@@ -0,0 +1,82 @@
+/* Based on Arabic (RTL) version of WordPress Classic theme, converted by Serdal (Serdal.com) */
+
+#menu ul ul, #wp-calendar caption, #wp-calendar #prev a { text-align: right; }
+#wp-calendar #next a, .feedback { text-align: left; }
+
+blockquote {
+	border-left: 0;
+	border-right: 5px solid #ccc;
+	margin-left: auto;
+	margin-right: 1.5em;
+	padding-left: 0;
+	padding-right: 5px;
+}
+
+body { font-family: 'Geeza Pro', Tahoma, 'Lucida Grande', 'Lucida Sans Unicode', Verdana, sans-serif; }
+
+h2 { font: 95% 'Al Bayan', 'Traditional Arabic', "Times New Roman", Times, serif; }
+
+p, li, .feedback {
+	font: 90%/175% 'Geeza Pro', Tahoma, 'Lucida Grande', 'Lucida Sans Unicode', Verdana, sans-serif;
+	text-align: justify;
+}
+
+acronym, abbr, span.caps, h2, p, li, #header, #menu ul li, #menu ul ul li, #wp-calendar td, .feedback, .meta, .meta a { letter-spacing: normal; }
+
+#commentlist li ul {
+	border-left: 0;
+	border-right: 1px solid #ddd;
+}
+
+#content {
+	margin: 30px 3em 0 13em;
+	padding-right: 0;
+	padding-left: 60px;
+}
+
+#header {
+	border-left: solid 1px #9a9;
+	border-right: solid 1px #565;
+	font: normal normal 230% 'Al Bayan', 'Traditional Arabic', 'Times New Roman', Times, serif;
+	padding: 15px 60px 15px 10px;
+}
+
+#menu {
+	border-left: 0;
+	border-right: 1px dotted #ccc;
+	padding: 20px 30px 10px 0;
+	right: auto;
+	left: 2px;
+}
+
+#menu form { margin: 0 13px 0 0; }
+
+#menu ul {
+	padding-left: 0;
+	padding-right: 3px;
+}
+
+#menu ul li { font: normal normal 110% 'Geeza Pro', Tahoma, 'Times New Roman', Times, serif; }
+
+#menu ul ul li {
+	font: normal normal 12px/115% 'Geeza Pro', Tahoma, 'Lucida Grande', 'Lucida Sans Unicode', Verdana, sans-serif;
+	padding-left: 0;
+	padding-right: 12px;
+}
+
+#menu ul ul ul.children {
+	padding-left: 0;
+	padding-right: 4px;
+}
+
+#wp-calendar #next a {
+	padding-right: 0;
+	padding-left: 10px;
+}
+
+#wp-calendar #prev a {
+	padding-left: 0;
+	padding-right: 10px;
+}
+
+#wp-calendar td { font: normal normal 12px 'Geeza Pro', Tahoma, 'Lucida Grande', 'Lucida Sans Unicode', Verdana, sans-serif; }
Index: wp-content/themes/default/rtl.css
===================================================================
--- wp-content/themes/default/rtl.css	(revision 5797)
+++ wp-content/themes/default/rtl.css	(working copy)
@@ -3,19 +3,24 @@
 .narrowcolumn, .alignleft, .widecolumn .smallattachment { float: right; }
 .alignright, #commentform #submit { float: left; }
 
-#page, #wp-calendar #prev a { text-align: right; }
+#page, .post, #wp-calendar #prev a { text-align: right; }
 
+body, #commentform p { font-family: 'Geeza Pro', Tahoma, 'Lucida Grande', Verdana, Arial, Sans-Serif; }
 
-body, #commentform p { font-family: Tahoma, 'Lucida Grande', Verdana, Arial, Sans-Serif; }
+small { font-family: 'Geeza Pro', Tahoma, Arial, Helvetica, Sans-Serif; }
 
-small { font-family: Tahoma, Arial, Helvetica, Sans-Serif; }
+h1, h2, h3 { font-family: 'Al Bayan', 'Traditional Arabic', 'Trebuchet MS', 'Lucida Grande', Verdana, Arial, Sans-Serif; }
 
-.commentlist li, #commentform input, #commentform textarea { font: 0.9em Tahoma, 'Lucida Grande', Verdana, Arial, Sans-Serif; }
+#sidebar h2 { font-family: 'Al Bayan', 'Traditional Arabic', 'Lucida Grande', Verdana, Sans-Serif; }
 
-#sidebar { font: 1em Tahoma, 'Lucida Grande', Verdana, Arial, Sans-Serif; }
+.commentlist li, #commentform input, #commentform textarea { font-family: 'Geeza Pro', Tahoma, 'Lucida Grande', Verdana, Arial, Sans-Serif; }
 
-#wp-calendar caption { font: bold 1.3em Tahoma, 'Lucida Grande', Verdana, Arial, Sans-Serif; }
+#sidebar { font-family: 'Geeza Pro', Tahoma, 'Lucida Grande', Verdana, Arial, Sans-Serif; }
 
+#wp-calendar caption { font-family: 'Geeza Pro', Tahoma, 'Lucida Grande', Verdana, Arial, Sans-Serif; }
+
+acronym, abbr, span.caps { letter-spacing: normal; }
+
 #header { margin: 0 1px 0 0; }
 
 .narrowcolumn { padding: 0 45px 20px 0; }
@@ -40,24 +45,34 @@
 
 .commentlist p { margin: 10px 0 10px 5px; }
 
-#sidebar { margin-right: 545px; }
-
-#wp-calendar #prev a, html>body .entry ul { padding-right: 10px; }
-
 html>body .entry li { margin: 7px 10px 8px 0; }
 
 html>body .entry ul {
+	margin-left: auto;
 	margin-right: 0px;
 	padding: 0 30px 0 0;
 }
 
+#sidebar {
+	margin-left: auto;
+	margin-right: 545px;
+}
+
+#wp-calendar #prev a, html>body .entry ul {
+	padding-left: 0;
+	padding-right: 10px;
+}
+
 blockquote {
+	border-left: 0;
+	border-right: 5px solid #ddd;
+	padding-left: 0;
+	padding-right: 20px;
 	margin: 15px 10px 0 30px;
-	padding-right: 20px;
-	border-right: 5px solid #ddd;
 }
 
 #wp-calendar #next a {
+	padding-right: 0;
 	padding-left: 10px;
 	text-align: left;
 }