Index: wp-admin/users.php
===================================================================
--- wp-admin/users.php	(revision 15495)
+++ wp-admin/users.php	(working copy)
@@ -168,6 +168,8 @@
 <ul>
 <?php
 	$go_delete = false;
+	$have_posts = false;
+		
 	foreach ( (array) $userids as $id ) {
 		$id = (int) $id;
 		$user = new WP_User($id);
@@ -178,6 +180,10 @@
 			$go_delete = true;
 		}
 	}
+	
+	if( $go_delete && have_many_users_links( $userids ) && have_many_users_posts( $userids ) ) 
+		$have_posts = true;
+		
 	// @todo Delete is always for !is_multisite(). Use API.
 	if ( !is_multisite() ) {
 		$all_logins = $wpdb->get_results("SELECT ID, user_login FROM $wpdb->users ORDER BY user_login");
@@ -193,6 +199,7 @@
 	?>
 	</ul>
 <?php if ( $go_delete ) : ?>
+<?php if ( $have_posts ) : ?>
 	<fieldset><p><legend><?php _e('What should be done with posts and links owned by this user?'); ?></legend></p>
 	<ul style="list-style:none;">
 		<li><label><input type="radio" id="delete_option0" name="delete_option" value="delete" checked="checked" />
@@ -200,6 +207,9 @@
 		<li><input type="radio" id="delete_option1" name="delete_option" value="reassign" />
 		<?php echo '<label for="delete_option1">'.__('Attribute all posts and links to:')."</label> $user_dropdown"; ?></li>
 	</ul></fieldset>
+<?php else : ?>
+ <input type="hidden" name="delete_option" value="delete" />   
+<?php endif; ?>
 	<input type="hidden" name="action" value="dodelete" />
 	<p class="submit"><input type="submit" name="submit" value="<?php esc_attr_e('Confirm Deletion'); ?>" class="button-secondary" /></p>
 <?php else : ?>
@@ -274,7 +284,8 @@
 <ul>
 <?php
 	$go_remove = false;
- 	foreach ( $userids as $id ) {
+
+ 	foreach ( (array) $userids as $id ) {
 		$id = (int) $id;
  		$user = new WP_User($id);
 		if ( $id == $current_user->id && !is_super_admin() ) {
@@ -286,6 +297,8 @@
 			$go_remove = true;
 		}
  	}
+		
+	
  	?>
 <?php if ( $go_remove ) : ?>
 		<input type="hidden" name="action" value="doremove" />
Index: wp-includes/user.php
===================================================================
--- wp-includes/user.php	(revision 15495)
+++ wp-includes/user.php	(working copy)
@@ -189,6 +189,68 @@
 }
 
 /**
+ * Checks if user has written any posts
+ *
+ * @uses $wpdb WordPress database object for queries.
+ *
+ * @param int $userid User ID.
+ * @return bool False if no posts have been found, true otherwise
+ */
+function has_user_posts($userid) {
+	global $wpdb;
+	$userid = (int) $userid;
+	$where = get_posts_by_author_sql('post', TRUE, $userid);
+	$count = $wpdb->get_var( "SELECT post_author FROM $wpdb->posts $where LIMIT 1", $userid );
+	return $count ? true : false;
+}
+
+/**
+ * Checks if users have written any posts
+ *
+ * @param array $userid User ID number list.
+ * @return bool False if no posts have been found, true otherwise
+ */
+function have_many_users_posts($users) {
+	global $wpdb;
+	if ( ! is_array($users) || empty( $users ) )
+		return false;
+	$userlist = implode( ',', $users );
+	$where = get_posts_by_author_sql( 'post' );
+	$result = $wpdb->get_results( "SELECT post_author FROM $wpdb->posts $where AND post_author IN ($userlist) LIMIT 1", ARRAY_N );
+	return $result ? true : false;
+}
+
+/**
+ * Checks if user has added any links
+ *
+ * @uses $wpdb WordPress database object for queries.
+ *
+ * @param int $userid User ID.
+ * @return bool False if no links have been found, true otherwise
+ */
+function has_user_links($userid) {
+	global $wpdb;
+	$userid = (int) $userid;
+	$count = $wpdb->get_var( "SELECT link_id FROM $wpdb->links WHERE link_owner = %d LIMIT 1", $userid );
+	return $count ? true : false;
+}
+
+/**
+ * Checks if users have added any links
+ *
+ * @param array $userid User ID number list.
+ * @return bool False if no links have been found, true otherwise
+ */
+function have_many_users_links($users) {
+	global $wpdb;
+	if ( ! is_array($users) || empty( $users ) )
+		return false;
+	$userlist = implode( ',', $users );
+	$result = $wpdb->get_results( "SELECT link_owner FROM $wpdb->links WHERE link_owner IN ($userlist) LIMIT 1", ARRAY_N );
+	return $result ? true : false;
+}
+
+/**
  * Check that the user login name and password is correct.
  *
  * @since 0.71